<?php
require_once("../../config/config_dir_raiz.php");
$config = new Config();
require_once($config->diretorio_raiz()."/src/controller/Funcoes_bd.php");
require_once($config->diretorio_raiz()."/src/model/Bi_unidade_recorrencia.php");
class Bi_unidade_recorrenciaDAO
{
	private $_funcoes_bd;
	private $_banco_atual;
	private $conexao;
	function __construct()
	{
		$this->conexao = Conexao::obterConexao();
		$this->_banco_atual = Conexao::getUtilizarBanco();
		$this->_funcoes_bd = new Funcoes_bd();
	}
	public function salvar($bi_unidade_recorrencia)
	{
		$inputs = array();
		if($bi_unidade_recorrencia->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_unidade_recorrencia->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_unidade_recorrencia->getUnidade() != "")
		{
			array_push($inputs, array('campo'=>':unidade', 'valor'=>$bi_unidade_recorrencia->getUnidade()));
		}
		else
		{
			array_push($inputs, array('campo'=>':unidade', 'valor'=>null));
		}
		try
		{
			$sql = "INSERT INTO bi_unidade_recorrencia (codigo, unidade) VALUES (:codigo, :unidade)  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function buscarBi_unidade_recorrencia($codigo)
	{
		$inputs = array();
		array_push($inputs, array('campo'=>':codigo', 'valor'=>$codigo));
		$sql = "SELECT * FROM bi_unidade_recorrencia where codigo = :codigo "; 
		$bi_unidade_recorrencia = new Bi_unidade_recorrencia();
		$rows_bi_unidade_recorrencia = $this->_funcoes_bd->sqlArrayInputs($sql, $inputs);
		foreach ($rows_bi_unidade_recorrencia as $row)
		{
			$bi_unidade_recorrencia->setCodigo($row['codigo']);
			$bi_unidade_recorrencia->setUnidade($row['unidade']);
		}
		return $bi_unidade_recorrencia;
	}
	public function buscarFiltro($where)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_unidade_recorrencia  ".$where;
		$lista_bi_unidade_recorrencia = array();
		$rows_bi_unidade_recorrencia = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_unidade_recorrencia as $row)
		{
			$bi_unidade_recorrencia = new Bi_unidade_recorrencia();
			$bi_unidade_recorrencia->setCodigo($row['codigo']);
			$bi_unidade_recorrencia->setUnidade($row['unidade']);
			array_push($lista_bi_unidade_recorrencia, $bi_unidade_recorrencia);
		}
		return $lista_bi_unidade_recorrencia;
	}
	public function atualizar($bi_unidade_recorrencia)
	{
		$inputs = array();
		if($bi_unidade_recorrencia->getCodigo() != "")
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_unidade_recorrencia->getCodigo()));
		}
		else
		{
			array_push($inputs, array('campo'=>':codigo', 'valor'=>null));
		}
		if($bi_unidade_recorrencia->getUnidade() != "")
		{
			array_push($inputs, array('campo'=>':unidade', 'valor'=>$bi_unidade_recorrencia->getUnidade()));
		}
		else
		{
			array_push($inputs, array('campo'=>':unidade', 'valor'=>null));
		}
		try
		{
			$sql = "UPDATE  bi_unidade_recorrencia  SET codigo = :codigo, unidade = :unidade WHERE codigo = :codigo  ";
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function excluir($bi_unidade_recorrencia)
	{
		try
		{
			$sql = "DELETE FROM bi_unidade_recorrencia  WHERE codigo =  :codigo ";
			$inputs = array();
			array_push($inputs, array('campo'=>':codigo', 'valor'=>$bi_unidade_recorrencia->getCodigo()));
			return $this->_funcoes_bd->executarSql($sql,$inputs);
		}
		catch (Exception $e)
		{
			throw new Exception($e->getMessage());
		}
	}
	public function listarTodosRegistros()
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_unidade_recorrencia";
		$listaBi_unidade_recorrencia = array();
		$rows_bi_unidade_recorrencia = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_unidade_recorrencia as $row)
		{
			$bi_unidade_recorrencia = new Bi_unidade_recorrencia();
			$bi_unidade_recorrencia->setCodigo($row['codigo']);
			$bi_unidade_recorrencia->setUnidade($row['unidade']);
			array_push($listaBi_unidade_recorrencia,$bi_unidade_recorrencia );
		}
		return $listaBi_unidade_recorrencia;
	}
	public function buscarBi_unidade_recorrenciaPorUnidade($unidade)
	{
		$inputs = array();
		$sql = "SELECT * FROM bi_unidade_recorrencia where unidade like '%".$unidade."%'";
		$lista_bi_unidade_recorrencia = array();
		$rows_bi_unidade_recorrencia = $this->_funcoes_bd->sql($sql);
		foreach ($rows_bi_unidade_recorrencia as $row)
		{
			$bi_unidade_recorrencia = new Bi_unidade_recorrencia();
			$bi_unidade_recorrencia->setCodigo($row['codigo']);
			$bi_unidade_recorrencia->setUnidade($row['unidade']);
			array_push($lista_bi_unidade_recorrencia, $bi_unidade_recorrencia);
		}
		return $lista_bi_unidade_recorrencia;
	}
}